package com.declan.textgrid;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONObject;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlPullParserFactory;

import com.declan.textgrid.R.color;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.util.Xml;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

public class Main extends Activity {

	
	
	// private LinearLayout topContainer;
	// private LinearLayout bottomContainer;

	private LinearLayout topContainer;
	private LinearLayout bottomContainer;

	TextView descriptionText;
	TextView descriptionText1;

	
	
	String builderString;
	String content;
	String test;
	JSONObject jArray = null;
	public String ds=null;

	int size = 70;
	public TextView[] textViews = new TextView[size];
	public View[] views = new View[size];
	public TextView[] titleTextViews = new TextView[size];
	public ImageView[] imageViews = new ImageView[size];

	
	
	
	public String texty;
	public String descriptionString;
	public ArrayList<String> texts = new ArrayList<String>();
	public ArrayList<String> descriptions = new ArrayList<String>();
	public ArrayList<String> imageURLS = new ArrayList<String>();
	public ArrayList<Bitmap> bitmap = new ArrayList<Bitmap>();
	public ArrayList<String> urls = new ArrayList<String>();
	
	
	public Document doc;

	public boolean rteOn = true;
	public boolean theTimesOn = true;
	public boolean theJournalOn = true;
	public boolean breakingNewsOn = true;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		
		
			
		
		setContentView(R.layout.main);
		
		Intent in = getIntent();
		boolean [] bools = in.getBooleanArrayExtra("bools");
		
		String rteB = getIntent().getStringExtra("rte");
		String journoB = getIntent().getStringExtra("journal");
		String breakingB = getIntent().getStringExtra("breaking");
		String nul = null;
		if(rteB!=null)rteOn = Boolean.valueOf(rteB);
		if(journoB!=null)theJournalOn = Boolean.valueOf(journoB);
		if(breakingB!=null)breakingNewsOn = Boolean.valueOf(breakingB);
		
		
		
		
		TextView tv = (TextView)findViewById(R.id.title_bar);
		tv.setText("Irish News");
		Button rte = (Button)findViewById(R.id.rtebutton);
		if(rteOn==false)
			rte.setBackgroundColor(color.button_background);
		rte.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				
				if(rteOn==true){
					rteOn = false;
					
				}else
					rteOn=true;
			
			String rteon = ""+rteOn;
			String journalon = ""+theJournalOn;
			String breakingon = ""+breakingNewsOn;
			Intent i = new Intent(Main.this,Main.class);
			i.putExtra("rte", rteon);
			i.putExtra("journal", journalon);
			i.putExtra("breaking", breakingon);
			startActivity(i);
	        }});
		Button journal = (Button)findViewById(R.id.journalbutton);
		if(theJournalOn==false)
			journal.setBackgroundColor(color.button_background);
		
		journal.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				
				if(theJournalOn==true)
					theJournalOn = false;
				else
					theJournalOn=true;
				
				String rteon = ""+rteOn;
				String journalon = ""+theJournalOn;
				String breakingon = ""+breakingNewsOn;
				Intent i = new Intent(Main.this,Main.class);
				//i.putExtra("bools", these);
				i.putExtra("rte", rteon);
				i.putExtra("journal", journalon);
				i.putExtra("breaking", breakingon);
				startActivity(i);
	        }});
		Button breaking = (Button)findViewById(R.id.breakingbutton);
		if(breakingNewsOn==false)
				breaking.setBackgroundColor(color.button_background);
		breaking.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				
				if(breakingNewsOn==false){
					breakingNewsOn = true;
					
				}
				else 
					breakingNewsOn=false;
				
				String rteon = ""+rteOn;
				String journalon = ""+theJournalOn;
				String breakingon = ""+breakingNewsOn;
				Intent i = new Intent(Main.this,Main.class);
				//i.putExtra("bools", these);
				i.putExtra("rte", rteon);
				i.putExtra("journal", journalon);
				i.putExtra("breaking", breakingon);
				startActivity(i);
	        }});
		Button refresh = (Button)findViewById(R.id.reload);
		
		refresh.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				for (int x = 0; x < size; x++) {

					titleTextViews[x].setText("Reloading!");
					textViews[x].setText("Reloading!");

					
				}
				
				refresh();
	        }});
		
		new AsyncTaskStuff().execute();
		populateData();
		
	}
	void refresh()
	{
		new AsyncTaskStuff().execute();
	}
	public void populateData()
	{
		topContainer = (LinearLayout) findViewById(R.id.top_container);
		bottomContainer = (LinearLayout) findViewById(R.id.bottom_container);
		
		
		this.makeArraysOfThings();
		
		if(rteOn==false)
			size=size-20;
		if(theJournalOn==false)
			size=size-40;
		if(breakingNewsOn==false)
			size = size - 10;
		
		for (int x = 0; x < size; x++) {

			views[x] = this.getLayoutInflater().inflate(R.layout.grid_item,
					null);
			titleTextViews[x] = (TextView) views[x].findViewById(R.id.grid_item_title);
			textViews[x] = (TextView) views[x]
					.findViewById(R.id.grid_item_description);
			imageViews[x] = (ImageView) views[x].findViewById(R.id.grid_item_image);
			
			
			
			textViews[x].setText("Loading...");

			imageViews[x].setImageResource(R.drawable.news);

			if (x % 2 == 0)
				topContainer.addView(views[x]);
			else
				bottomContainer.addView(views[x]);
		}
	}
	
	
	public void makeArraysOfThings() {
		
		for (int x = 0; x < size; x++) {
			textViews[x] = new TextView(this);
			textViews[x].setTag("" + x); // set tag with index x.
			views[x] = new View(this);
			views[x].setTag("" + x); // set a tag with index x.
			titleTextViews[x]=new TextView(this);
			titleTextViews[x].setTag(""+x);
			imageViews[x] = new ImageView(this);
			
			
			
		}

	}

	private class AsyncTaskStuff extends AsyncTask<String, Void, String> {
		
		
		
		
		protected void onPostExecute(String result) {
			super.onPostExecute(result);
			
			
			
			
			for(int i=0;i<descriptions.size();i++) { 
				titleTextViews[i].setText(texts.get(i)); 
				textViews[i].setText(descriptions.get(i)); 
				
				if(i<bitmap.size())
				{//Toast.makeText(getApplicationContext(), ""+imageURLS.get(0), Toast.LENGTH_SHORT).show();
					imageViews[i].setImageBitmap(bitmap.get(i));
					imageViews[i].setId(i);
					imageViews[i].setOnClickListener(new OnClickListener() {
						public void onClick(View v) {
							//Toast.makeText(v.getContext(), ""+urls.get(v.getId()), Toast.LENGTH_SHORT).show();
							int a = 0;
							a = v.getId();
							String stuff = "";
							stuff = (stuff + texts.get(a));
							
							
							Intent intent = new Intent(Main.this, ArticlePage.class);
							intent.putExtra("title", stuff);
							startActivity(intent);
				        }
			                    
		                }
		            );
				}
				else if(i>=bitmap.size())
					imageViews[i].setImageResource(R.drawable.news);
					imageViews[i].setId(i);
					imageViews[i].setOnClickListener(new OnClickListener() {
						public void onClick(View v) {
				            //Toast.makeText(v.getContext(), ""+urls.get(v.getId()), Toast.LENGTH_SHORT).show();
							int a = v.getId();
							String stuff = "";
							stuff = (stuff + urls.get(a));
							Intent intent = new Intent(Main.this, ArticlePage.class);
							intent.putExtra("title", stuff);
					        startActivity(intent);
				        }
	            }); 
				} 
				
			
				
			
			
				
			
			
		}

		public InputStream getInputStream(URL url) {   /// taken from web tutorial
			   try {
			       return url.openConnection().getInputStream();
			   } catch (IOException e) {
			       return null;
			     }
			}
		
		
		@Override
		protected String doInBackground(String... params) {
			
			if(!texts.isEmpty())
				texts.clear();
			if(!descriptions.isEmpty())
				descriptions.clear();
			if(!imageURLS.isEmpty())
				imageURLS.clear();
			if(!bitmap.isEmpty())
				bitmap.clear();
			if(!urls.isEmpty())
				urls.clear();
			
			getDataForFeed();
			
			
			
			return texty;
	}
		
		public void getDataForFeed()
		{
			if(rteOn==true)	
				getRSSDataForRTE();
			//if(theJournalOn==true)
				//journalData();
			//if(theTimesOn==true)
			//	timesData();
			if(breakingNewsOn==true)
				breakingNewsData();
		}
		public void getRSSDataForRTE()  // function to get rte data
		{
			String link;
			String imageURLString;
			try {
				URL url = new URL("http://www.rte.ie/news/rss/news-headlines.xml");
				XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
				factory.setNamespaceAware(false);
				XmlPullParser xpp = factory.newPullParser();
				
				xpp.setInput(getInputStream(url), "UTF_8");
				boolean insideItem = false;
				int eventType = xpp.getEventType();
				int x=0;
				while (eventType != XmlPullParser.END_DOCUMENT) {
					if (eventType == XmlPullParser.START_TAG) {
						
						if (xpp.getName().equalsIgnoreCase("item")) {
							insideItem = true;
						} else if (xpp.getName().equalsIgnoreCase("title")) {
								texty = xpp.nextText();
								if(!texts.contains(texty))
								texts.add(texty);
								if(texts.contains("RT News - News Headlines"))
									texts.remove("RT News - News Headlines");
							
						} else if (xpp.getName().equalsIgnoreCase("description")) {
							descriptionString = xpp.nextText();
							if(!descriptions.contains(descriptionString))
								if(!descriptionString.equals("Latest Irish and international news supplied by RT.ie"));
									descriptions.add(descriptionString);
									
									
									
								descriptions.remove("Latest Irish and international news supplied by RTE.ie");
						}else if(xpp.getName().equalsIgnoreCase("link")){
							link = xpp.nextText();
							
							if(urls.contains("http://www.rte.ie/news/"))
								urls.remove("http://www.rte.ie/news/");
							if(urls.contains("http://www.rte.ie/news"))
								urls.remove("http://www.rte.ie/news");
							if(!urls.contains(link))
									urls.add(link);
							
							
						}
						else if (xpp.getName().equalsIgnoreCase("enclosure")){
							imageURLString = xpp.getAttributeValue(0);
							imageURLS.add(imageURLString);	
							try {
								  
								  bitmap.add(BitmapFactory.decodeStream((InputStream)new URL(imageURLString).getContent()));
								  
								} catch (MalformedURLException e) {
								  e.printStackTrace();
								} catch (IOException e) {
								  e.printStackTrace();
								}
						}
					}else if(eventType==XmlPullParser.END_TAG && xpp.getName().equalsIgnoreCase("item")){
						insideItem=false;
					}
					x++;
					eventType = xpp.next(); //move to next element
				}	
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (XmlPullParserException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		//////Journal data
		public void journalData()
		{
			
			String imageURLString;
			String link;
			try {
				URL url = new URL("http://www.thejournal.ie/feed/");
				XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
				factory.setNamespaceAware(false);
				XmlPullParser xpp = factory.newPullParser();
				
				xpp.setInput(getInputStream(url), "UTF_8");
				
				boolean insideItem = false;
				int eventType = xpp.getEventType();
				int x=0;
				while (eventType != XmlPullParser.END_DOCUMENT) {
					if (eventType == XmlPullParser.START_TAG) {
						
						if (xpp.getName().equalsIgnoreCase("entry")) {
							insideItem = true;
						} else if (xpp.getName().equalsIgnoreCase("title")) {
								texty = xpp.nextText();
								if(!texts.contains(texty))
								texts.add(texty);
								if(texts.contains("TheJournal.ie"))
									texts.remove("TheJournal.ie");
							
						} else if (xpp.getName().equalsIgnoreCase("summary")) {
							descriptionString = xpp.nextText();
							if(!descriptions.contains(descriptionString))
									descriptions.add(descriptionString);
						}else if(xpp.getName().equalsIgnoreCase("link") && xpp.getAttributeName(0).equals("href")){
							link = xpp.getAttributeValue(0);
							if(urls.contains("http://www.thejournal.ie"))
								urls.remove("http://www.thejournal.ie");
							if(urls.contains(link)){
								urls.remove(link);
							}
							urls.add(link);
						}
						else if(xpp.getName().equalsIgnoreCase("link") && xpp.getAttributeValue(0).equals("replies")){
							eventType=xpp.next();
						}
						else if(xpp.getName().equalsIgnoreCase("link") && xpp.getAttributeName(2).equals("href")){
							imageURLString = xpp.getAttributeValue(2);
							imageURLS.add(imageURLString);
							imageURLS.remove("http://www.thejournal.ie");
							try {
								if(!imageURLString.equals("http://www.thejournal.ie"))
								  	bitmap.add(BitmapFactory.decodeStream((InputStream)new URL(imageURLString).getContent()));
								  
								} catch (MalformedURLException e) {
								  e.printStackTrace();
								} catch (IOException e) {
								  e.printStackTrace();
								}
						}
					}else if(eventType==XmlPullParser.END_TAG && xpp.getName().equalsIgnoreCase("entry")){
						insideItem=false;
					}
					x++;
					eventType = xpp.next(); //move to next element
				}	
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (XmlPullParserException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		/*
		public void timesData()
		{
			String link = "";
			String imageURLString;
			try {
				URL url = new URL("http://rss.feedsportal.com/c/851/f/10845/index.rss");
				XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
				factory.setNamespaceAware(false);
				XmlPullParser xpp = factory.newPullParser();
				
				xpp.setInput(getInputStream(url), "UTF_8");
				boolean insideItem = false;
				int eventType = xpp.getEventType();
				int x=0;
				while (eventType != XmlPullParser.END_DOCUMENT) {
					if (eventType == XmlPullParser.START_TAG) {
						
						if (xpp.getName().equalsIgnoreCase("channel")) {
							insideItem = true;
						} else if (xpp.getName().equalsIgnoreCase("title")) {
								texty = xpp.nextText();
								if(!texts.contains(texty))
								texts.add(texty);
								
							
						} else if (xpp.getName().equalsIgnoreCase("description")) {
							descriptionString = xpp.nextText();
							if(!descriptions.contains(descriptionString))
									descriptions.add(descriptionString);
						}else if(xpp.getName().equalsIgnoreCase("link")){
							link = xpp.nextText();
							if(!urls.contains(link))
								urls.add(link);
							
							if(urls.contains("http://www.irishtimes.com"))
								urls.remove("http://www.irishtimes.com");
							
						}
					}else if(eventType==XmlPullParser.END_TAG && xpp.getName().equalsIgnoreCase("channel")){
						insideItem=false;
					}
					x++;
					eventType = xpp.next(); //move to next element
				}	
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (XmlPullParserException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		} */
		public void breakingNewsData()
		{
			String link = "";
			String imageURLString;
			try {
				URL url = new URL("http://feeds.breakingnews.ie/bntopstories");
				XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
				factory.setNamespaceAware(false);
				XmlPullParser xpp = factory.newPullParser();
				
				xpp.setInput(getInputStream(url), "UTF_8");
				boolean insideItem = false;
				int eventType = xpp.getEventType();
				int x=0;
				while (eventType != XmlPullParser.END_DOCUMENT) {
					if (eventType == XmlPullParser.START_TAG) {
						
						if (xpp.getName().equalsIgnoreCase("channel")) {
							insideItem = true;
						} else if (xpp.getName().equalsIgnoreCase("title")) {
								texty = xpp.nextText();
								if(!texts.contains(texty)&& texty!=("Ireland: BreakingNews.ie"))
								texts.add(texty);
								
								texts.remove("Ireland: BreakingNews.ie");
								texts.remove("BreakingNews.ie");
								texts.remove("Top Stories: BreakingNews.ie");
							
						} else if (xpp.getName().equalsIgnoreCase("description")) {
							descriptionString = xpp.nextText();
							if(!descriptions.contains(descriptionString))
									descriptions.add(descriptionString);
							
							descriptions.remove("Ireland's premier breaking news website providing up to the minute news and sports reports.");
							
						}else if(xpp.getName().equalsIgnoreCase("link")){
							link = xpp.nextText();
							
							if(!urls.contains(link)){
								urls.add(link);
							}
							
							urls.remove("http://www.breakingnews.ie/?rss=rss2");
							
							
						}
					}else if(eventType==XmlPullParser.END_TAG && xpp.getName().equalsIgnoreCase("channel")){
						insideItem=false;
					}
					x++;
					eventType = xpp.next(); //move to next element
				}	
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (XmlPullParserException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	
	
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	}
	}

